
/*
 *  Copyright  (c)  L.Allison, C.S.Wallace, C.N.Yee.
 *     Dept. Computer Science, Monash University, Australia 3168,    May 1991.
 *  1. These routines may only be used for non-commercial, non-classified,
 *     research purposes.
 *  2. No liability of any kind is accepted for their use.
 *  3. As a courtesy, please inform us of any interesting uses of the routines,
 *     of any bugs that you find in them and of how to correct
 *     such bugs, if known.
 *  4. Do not delete this copyright notice.
 *  5. Please include the following references in any publication based wholly
 *     or in part on the use of these routines or on the ideas contained in them:
 *   . Allison L. & C.N.Yee.
 *        Minimum Message Length Encoding and the Comparison of Macro-Molecules.
 *        Bull. Math. Bio. 52(3) 431-453 1990
 *   . Allison L., C.S.Wallace & C.N.Yee. Finite-State Models in the Alignment
 *        of Macromolecules. J. Mol. Evol. (1992) 35:77-89
 *  6. You may distribute the routines to others if and only if
 *     they agree to accept and maintain these conditions and no fee is charged.
 *  7. There is no rule 7.
 */
/*
 *	"3States.h"  declarations for 3 States R-theory.
 */
#define K	4	/* number of arcs in each state */

#define fwd 0 
#define rev 1 

#define adaptive	0 
#define fixed	 	1 

#define BIG	-1e7

typedef struct {
	float D, H, V ;		/* probs that the machine is in these states */
	float DM, DC, DH, DV ; /* probs of the arcs */
	float HM, HC, HH, HV ;
	float VM, VC, VH, VV ;
} ThreeStatesPBlock ;

typedef struct {
	float D, H, V ;		/* cost of the three states */
	float DM, DC, DH, DV ; /*weighted frequency counters*/
	float HM, HC, HH, HV ;
	float VM, VC, VH, VV ;
} cell ;

typedef struct {
	float D, H, V ;
} pcell ;

#define FREE 0
#define SYMM 1
/*
 * the free adapting version and the symmetric version
 */
#define ThreeStatesML(A,B,MesgLength,MatrixPart,mode,outfile,P,Accurarcy) \
ThreeStatesMesLength(A,B,MesgLength,MatrixPart,mode,outfile,P,Accurarcy,FREE)

#define ThreeStatesMLS(A,B,MesgLength,MatrixPart,mode,outfile,P,Accurarcy)\
ThreeStatesMesLength(A,B,MesgLength,MatrixPart,mode,outfile,P,Accurarcy,SYMM)
