
/*
 *  Copyright  (c)  L.Allison, C.S.Wallace, C.N.Yee.
 *     Dept. Computer Science, Monash University, Australia 3168,    May 1991.
 *  1. These routines may only be used for non-commercial, non-classified,
 *     research purposes.
 *  2. No liability of any kind is accepted for their use.
 *  3. As a courtesy, please inform us of any interesting uses of the routines,
 *     of any bugs that you find in them and of how to correct
 *     such bugs, if known.
 *  4. Do not delete this copyright notice.
 *  5. Please include the following references in any publication based wholly
 *     or in part on the use of these routines or on the ideas contained in them:
 *   . Allison L. & C.N.Yee.
 *        Minimum Message Length Encoding and the Comparison of Macro-Molecules.
 *        Bull. Math. Bio. 52(3) 431-453 1990
 *   . Allison L., C.S.Wallace & C.N.Yee. Finite-State Models in the Alignment
 *        of Macromolecules. J. Mol. Evol. (1992) 35:77-89
 *  6. You may distribute the routines to others if and only if
 *     they agree to accept and maintain these conditions and no fee is charged.
 *  7. There is no rule 7.
 */
/*
 *	"Error.c"
 *	The setting up of default Error handling routines table
 */
#include <stdio.h>
#include "error.h"

/*
 *	returns the error string that corresponds the ErrCode
 */
char *ErrMesgStr(ErrCode)
{
	switch (ErrCode) {

	case ERRLineTooLong : return "String Too Long" ;
	case ERRBadChar : return "Bad Character Read" ;
	default :
		printf("ERROR TRAP: illegal Error Code %d\n", ErrCode) ;
		exit(99) ;
	}
	return NULL ;
}

int ErrMesgExit(ErrCode)
	int	ErrCode ;
{
	char *errmesg ;

	errmesg = ErrMesgStr(ErrCode) ;
	printf("%s\n", errmesg) ;
		
	exit(ErrCode) ;
}

int ErrMesgRet(ErrCode)
	int	ErrCode ;
{
	char *errmesg ;

	errmesg = ErrMesgStr(ErrCode) ;
	printf("%s\n", errmesg) ;
}

ErrFileOpen(filename)
	char filename[] ;
{
	printf("Error opening : %s\n",filename) ;
	exit(0) ;
}

int (*ErrorHandling[NError])() = {NULL, ErrMesgExit, ErrMesgRet, ErrFileOpen};
