
/*
 *  Copyright  (c)  L.Allison, C.S.Wallace, C.N.Yee.
 *     Dept. Computer Science, Monash University, Australia 3168,    May 1991.
 *  1. These routines may only be used for non-commercial, non-classified,
 *     research purposes.
 *  2. No liability of any kind is accepted for their use.
 *  3. As a courtesy, please inform us of any interesting uses of the routines,
 *     of any bugs that you find in them and of how to correct
 *     such bugs, if known.
 *  4. Do not delete this copyright notice.
 *  5. Please include the following references in any publication based wholly
 *     or in part on the use of these routines or on the ideas contained in them:
 *   . Allison L. & C.N.Yee.
 *        Minimum Message Length Encoding and the Comparison of Macro-Molecules.
 *        Bull. Math. Bio. 52(3) 431-453 1990
 *   . Allison L., C.S.Wallace & C.N.Yee. Finite-State Models in the Alignment
 *        of Macromolecules. J. Mol. Evol. (1992) 35:77-89
 *  6. You may distribute the routines to others if and only if
 *     they agree to accept and maintain these conditions and no fee is charged.
 *  7. There is no rule 7.
 */
#include <stdio.h>

/*
 *	general macro definitions
 */
#ifdef DEBUG
#define	debug(X)	X
#else
#define debug(X)
#endif

#define MAXINT	999999
#define infinity 1e20

#define LINELENGTH		75
#define SCREENHEIGHT 	40
#define SCREENWIDTH 	80

#define bool	int
#define	FALSE	0
#define	TRUE	1

char	*malloc() ;
FILE	*popen(), *fopen() ;
char	*strcat(), *strcpy() ;
int	strncmp() ;

#define min(x,y)	((x)<(y) ? (x):(y))
#define max(x,y)	((x)>(y) ? (x):(y))

/*  make sure that temp is declared with the appropriate type when
    this macro is used 
 */
#define swap(x,y)	{temp = x ; x = y ; y = temp ;}  

#define odd(n)	((n) % 2 ? TRUE : FALSE)
#define even(n)	((n) % 2 ? FALSE : TRUE)

#define abs(n) ((n) > 0 ? (n) : -(n))

int	min3() ;
float fmin2(), fmin3(), fmax3(), fmin5(), flabs() ;
long lmin3() ;
double log2(), exp2() ;
double lloyd(), riss(), logstar(), yee() ;
float  sumlg(), sumlg3(), sumlg5() ;
float  paramcost2(), paramcost3(), paramcost4(), paramcost6(), U() ;
int	randomnum() ;
float NullMesgLength(), DiffCode() ;

typedef	struct {
	int	x, y ; 	/* used as integer */
	} coord ;

extern double ln2 ;

float RCount() ;
